<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";
    $pathes = [ "../../pages", "../../services" ];
        
    $title_tags = [ "header title", "person name" ];

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

    $date_format = $_SESSION['ini_site_options']["date_format"];
?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Order by Tag</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$admin_root/_tools/_tools.css" ?>" />
        <style></style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
              
    // ====== remove Directory / begin ======
    function orderByTag($pathes, $tag, $reverse) {
    // ----------------------------------------
    // $pathes = <array> full directory PATHes
    // $tag = <string> XML Tag (eg. "header date")
    // $reverse = <boolean> Sort direction
    // ----------------------------------------
    // Sort pages by Tag
    // ----------------------------------------
        foreach($pathes as $path) {
            foreach(listDir($path, "/") as $folder) {
                $order_path = "$path/$folder/.order";
                $value_found = false;
                $by_value = [];
                $num = 0;
                if(substr($folder, 0 , 1) != "_" && ($order_xml = loadXml($order_path))) {
                    
                    $missing_date = [];
                    foreach($order_xml["multi_item"] as $item) {
                        $item_path = "$path/$folder/".readXml($item, "path");
                        $item_xml = loadXml($item_path, "draft", true);
                        $value = readXml($item_xml, $tag);

                        if(is_string($value) && $value != "") {
                            $by_value[$value."|".$num++] = $item;
                            $value_found = true;
                        }
                        else {
                            $by_value["0000-00-00|".$num++];
                            $missing_date[] = $item_path;
                        }
                    }
                    
                    echo "<b>Folder: "."$path/$folder"."</b><br>\n";
                    
                    if(!$value_found) {
                        echo "> No 'tag' value found.<br>\n";
                    }
                    elseif($missing_date) {
                        foreach($missing_date as $item_path) {
                            echo "> Missing value in: $item_path<br>\n";
                        }
                    }
                    else {
                        if($reverse) { krsort($by_value); }
                        else { ksort($by_value); };
                        $order_xml["multi_item"] = array_values($by_value);
                        //arrayList($order_xml);

                        //if(safeSave($order_path, XmlFileContent($order_xml))) {
                        //    echo "> Order file updated: $order_path<br>\n";
                        //}
                        if(safeSave($order_path, arrayToJson($order_xml)) {
                            echo "> Order file updated: $order_path<br>\n";
                        }
                        else {
                            echo "> File save error: $order_path<br>\n";
                        }
                    }
                    
                    echo "<hr>\n";
                }
            }
        }
    };
        
    echo "<h1>Order by Tag</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "update") {
        //arrayList($_POST);
        $reverse = isset($_POST["reverse"]);
        $tag = $_POST["tag"];
        if(isset($_POST["tag"]) && $_POST["tag"] != "") {
            orderByTag($pathes, $tag, $reverse);
        }
        else {
            echo "<p>ERROR! XML tag can't be empty!</p><br>\n";
        }
    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Specify XML Tag to update subpages order</p>\n";
        echo "<p>\n".
            "\t<input type='text' name='tag' value='header date' placeholder='XML tag'>\n".
            "\t<label><input type='checkbox' name='reverse' checked>Reverse</label>\n".
            "</p>\n";
        echo "<button name='action' value='update' type='submit'>Submit</button>\n";
        echo "</form>\n";
    };

?> 
        
    </body>
</html>