<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";
    $path = "$admin_root/localization";

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

    $date_format = $_SESSION['ini_site_options']["date_format"];
?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Localization to json</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$admin_root/_tools/_tools.css" ?>" />
        <style></style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
    function convertToJson($path) {
    // ----------------------------------------
    // $path = <string> full directory PATH
    // ----------------------------------------
    // Delete folder with it's content
    // ----------------------------------------
        echo "Folder: \"$path\"<hr>\n";
        foreach(listDir($path, "xml") as $file) {
            echo "> $file<br>\n";
            $xml = loadXml("$path/$file");
            $localization = [];
            foreach($xml["multi_sentence"] as $sentence) {
                $key = $sentence["key"][0]["string"][0];
                $localization[$key] = [];
                //echo "$key: {<br>\n";
                $translation = $sentence["translation"][0]["text"][0];
                foreach(array_keys($translation) as $language) {
                    $text = $translation[$language][0];
                    if($text != "") {
                        $text = str_replace("\\", "\\\\", $text);
                        $text = str_replace("\"", "\\\"", $text);
                        $text = str_replace("&gt;", ">", $text);
                        $text = str_replace("&lt;", "<", $text);
                        $text = str_replace("[br]", "<br>", $text);
                        $localization[$key][$language] = $text;
                    };
                }
                //echo "},<br>\n";
            }
            //arrayList($localization);
            $json = arrayToJson($localization);
            $json_path = "$path/".path($file, "filename").".json";
            safeSave($json_path, $json);
            echo "path: $json_path<br>\n";
            //echo "<textarea>".$json."</textarea>\n";
            
        }
    };
        
    echo "<h1>Admin Bak Delete</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "json") {
        convertToJson($path);
    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Convert localization files from XML to JSON?</p>\n";
        echo "<button name='action' value='json' type='submit'>Submit</button>\n";
        echo "</form>\n";
    };
?> 
        
    </body>
</html>