
// ==========================================
//           Draggable Gallery
// ==========================================

function launchDraggableGallery() {
    $("article section > .media > .gallery, article section > .media > .files").sortable({
        scroll: false,
        cancel: "a,button",
        items: "> div.thumb",
        update: function(event, ui) {
            galleryValueUpdate( $(this) );
        }
    });
};

function galleryValueUpdate($gallery) {
    var files = [];
    $gallery.find(".thumb").each(function() {
        files[files.length] = $(this).attr("path");
    })
    if(files.length) {
        $gallery.attr("value", files.join(";"));
    };
};

// ==========================================
//             Template media
// ==========================================

function templateUpload() {
    if(SAVE_PATH.path("extension") == "template") {
        var html = "<div class='thumb template'><label><p>@value</p></label></div>";
        $("article section > .media .upload").each(function() {
            val = $(this).parent().attr("value");
            $(this).replaceWith(html.replace("@value", val));
        })
    }
};

// ==========================================
//              File(s) upload
// ==========================================

var TAKEN_BY_UPLOAD = [];
var MAX_UPLOADS = parseInt( $("#site_max_uploads").val() );

function removeUninkedDescriptions() {
    var all_files = [];
    $("form section > div.media > div").each(function() {
        var val = $(this).attr("value");
        if(typeof(val) == "string") {
            all_files[all_files.length] = val;
        }
    });
    all_files = all_files.join(";");
    for(href in MEDIA_DESCRIPTIONS) {
        if(all_files.indexOf(href) < 0) {
            delete MEDIA_DESCRIPTIONS[href];
        }
    }
};

function UploadCancelFix() {
    // Fix label crash after Cancel
    $("input.upload_file").unbind("click").click(function() {
        $uploadButton = $(this);
        $(document).focusin(function() {
            $(document).unbind("focusin");
            $("#help_popup").remove();
            // If no files selected
            setTimeout(function() { // wait for data
                if($uploadButton.val() == "") {
                    //alert("nic");
                    $box = $uploadButton.closest(".upload");
                    $div = $box.parent();
                    box = $box.get(0).outerHTML
                    $box.remove();
                    $div.append(box); // rebuild upload button
                    initializeUpload();
                    initializeHelp();
                }
                else {
                    //alert("plik");
                    $($uploadButton).prop('disabled', true); // Prevent delete input content by next click & cancel. Must be unblocked -> deleteEmptyUploads()
                };
            }, 200);
        });
    });
};

function transparentBackground() {
    $("article .media .thumb").each(function() {
        img = $(this).css("background-image")
        if(jQuery.type( img ) == "string" && img != "" && img != "none") {
            img = img.replace(/url\(\"(.*?)\"\)/, "$1").path("basename");
            if(img.path("extension") == "png" || img.path("extension") == "svg") {
                $(this).css({ "background-color": "#eeeeee" });
            }
            else {
                $(this).css({ "background-color": "#ffffff" });
            };
        };
    });
};

function initializeLinkUpdate() { // for embeded content
    $("article div.media label.update_link").click(function() {
        $thumb = $(this).parent();
        showPopup("fi-link", LOCALIZE["video-label"], LOCALIZE["save-cancel-buttons"], LOCALIZE["video-input"]);
        // Confirm
        $("#popup_box .confirm").unbind("click").click(function() {
            input = $("#popup_box input").val();

            if(iframe = input.match(/\<iframe(.*?)src=\"(.*?)\"/)) {
                //alert(iframe[2]);
                input = iframe[2];
            };
            input = input.replace(/autoplay=true/, "autoplay=false");

            if(input == "") {
                infoPopup(LOCALIZE["empty-input-alert"]);
                $("#popup_box input").focus();
            }
            else if(input.split(" ").length > 1 || input.split(".").length < 2){
                infoPopup(LOCALIZE["valid-address-alert"]);
                $("#popup_box input").focus();
            }
            else {
                if(input.substr(0 , 7) != "http://" && input.substr(0 , 8) != "https://") {
                    input = "http://" + input;
                };

                // ====== YouTube ======
                if(input.indexOf("youtube.com") > -1) {
                    input = input.split("&").shift();
                    input = input.replace("youtube.com/watch?v=", "youtube.com/embed/");
                }
                else if(input.indexOf("youtu.be") > -1) {
                    input = input.split("?").shift();
                    input = input.replace("youtu.be", "youtube.com/embed/");
                };

                // ====== Facebook ======
                if(input.indexOf("facebook.com") > -1) {
                    if(input.indexOf("/videos/") == -1) { input = decodeURIComponent(input); }
                    id = input.split("/videos/").pop().split("/").shift();
                    input = "http://www.facebook.com/video/embed?video_id=" + id;
                };

                // ====== vimeo ======
                if(input.indexOf("vimeo.com") > -1) {
                    id = input.split("/").pop().split("?").shift();
                    input = "https://player.vimeo.com/video/" + id;
                }

                $thumb.closest("div.video").attr("value", input);
                $thumb.find("iframe").fadeIn(200).attr("src", input);
                $thumb.find("button").show(200);
                hidePopup();
            };
        });
        // Cancel
        $("#popup_box .cancel").unbind("click").click(function() {
            hidePopup();
        });
    });
};

function MediaPreviewUpdate($slide, slide_num) {
    var size = $slide.attr("size").split("x");
    // Update image
    var src = $slide.css("background-image").match(/"(.*?)"/).pop();
    $("#zoom img.image").attr("src", src);
    // Update text
    var path = $slide.attr("path");
    var filesize = $slide.attr("filesize");
    if(Object.keys(MEDIA_DESCRIPTIONS).indexOf(path) > -1) {
        var description = MEDIA_DESCRIPTIONS[path][ADMIN_LANG];//.replace("[br]", "\n");
    }
    else {
        var description = "";
    };

    $("#zoom .slide_num").html(slide_num);
    $("#zoom .filename").text(path.path("basename"));
    $("#zoom .dirname").text(path.path("dirname") + "/");
    $("#zoom .size").text( size.join(" x ") + " px" );
    $("#zoom .filesize").text( filesize + " kB" );
    $("#zoom .download").attr( "href", SITE_ROOT + "/" + path );
    $("#zoom .media_description").val(description);

    $("#zoom .media_description").unbind("blur").blur(function() { updateDescription(); });
};

function updateDescription() {
    var description = $("#zoom .media_description").val().replace("\n", "[br]");
    var path = $("#zoom .download").attr("href").substr(SITE_ROOT.length + 1);
    if(description != "" || Object.keys(MEDIA_DESCRIPTIONS).indexOf(path) > -1) { // Don't update if description is empty
        if(Object.keys(MEDIA_DESCRIPTIONS).indexOf(path) < 0) { MEDIA_DESCRIPTIONS[path] = {}; }
        MEDIA_DESCRIPTIONS[path][ADMIN_LANG] = description;
        var json = arrayToJson(MEDIA_DESCRIPTIONS);
        $("#media_descriptions").val(json);
    }
};

function initializeMediaPreview() {
// --------------------------------
// Initialize zoom or download button on media items
// --------------------------------
    // ====== File(s) Download ======
    $("article div.media .thumb .download").unbind("click").click(function() {
        var file = $(this).closest(".thumb").attr("path");
        window.open(SITE_ROOT + "/" + file, '_blank');
        $(this).blur();
        return false;
    });
    // ====== Image(s) Zoom ======
    $("article div.media .thumb .zoom").unbind("click").click(function() {
        $slide = $(this).closest(".thumb");
        $gallery = $slide.parent();

        var html = "<div id='page_fader'>\n" +
            "\t<div id='zoom'>\n" +

                "\t\t<div class='image_box'>\n" +
                    "\t\t\t\t<img class='image' src=''>\n" +
                    "\t\t\t\t<button class='toggle_slide prev'><span class='fi-arrow-left'></span></button>\n" +
                    "\t\t\t\t<button class='toggle_slide next'><span class='fi-arrow-right'></span></button>\n" +
                "\t\t</div>\n" +

                "\t\t<div class='text_box'>\n" +
                    "\t\t\t<p class='title'><span class='slide_num'>1 / n</span></p>\n" +
                    "\t\t\t<p class='filename'>filename.ext</p>\n" +
                    "\t\t\t<p class='info'><i class='fi-folder'></i><span class='dirname'>dirname/folder/</span></p>\n" +
                    "\t\t\t<p class='info'><i class='fi-photo'></i><span class='size'>100 x 100 px</span></p>\n" +
                    "\t\t\t<p class='info'><i class='fi-info'></i><span class='filesize'>1.00 Mb</span></p>\n" +
                    "\t\t\t<p class='download_button'><a class='download button' href='' target='_blank' download><i class='fi-download'></i>" + LOCALIZE["download-label"] + "</a></p>\n" +
                    "\t\t\t<textarea class='media_description' placeholder='" + LOCALIZE["description-label"] + "'></textarea>\n" +
                    "\t\t\t<button class='close'><span class='fi-x'></span></button>\n" +
                "\t\t</div>\n" +

            "\t</div>\n" +
            "</div>\n";
        $("body").append(html).css({ "overflow-y": "hidden" });
        $("#lang, #toogle_mobile_menu").fadeOut(ANIMATION_TIME * 0.5);
        $("#page_fader").fadeIn(ANIMATION_TIME);
        hideButtons($("header .float_buttons"));
        // Gallery slides
        if($gallery.length) {
            // Check for current slide number
            $prev = $slide;
            slide_num = 1;
            while($prev.prev(".thumb").length) {
                $prev = $prev.prev(".thumb");
                slide_num++;
            }
            slides_total = $gallery.find(".thumb").length;
            MediaPreviewUpdate($slide, slide_num + " / " + slides_total);
            
            slides_count = $gallery.find(".thumb").length;
            if(slides_count < 2) {
                $("#page_fader .toggle_slide").hide();
            }

            // ====== Disable window close on image Download ======
            $("#page_fader a.download").click(function() {
                $("body").css({ "overflow-y": "scroll" });
                return true;
            });

            // ====== Change slide ======
            $("#page_fader .toggle_slide").click(function() {
                $(this).blur();
                $("#zoom textarea").blur();
                var dir = $(this).attr("class").split(" ").pop();
                if(dir == "prev") {
                    $next = $slide.prev("div.thumb");
                    slide_num--;
                    if(!$next.length) {
                        $next = $gallery.find("div.thumb").last();
                        slide_num = slides_total;
                    };
                    dir = 110;
                }
                else {
                    $next = $slide.next("div.thumb");
                    slide_num++;
                    if(!$next.length) {
                        $next = $gallery.find("div.thumb").first();
                        slide_num = 1;
                    };
                    dir = -110;
                }
                $("#zoom img.image").animate({ "left": dir + "%" }, 250, function() {
                    $image = $(this);
                    $image.attr("src", ""); // Prevent showing previous image before load the new one
                    MediaPreviewUpdate($next, slide_num + " / " + slides_total);
                    $slide = $next;
                    setTimeout(function() {
                        $image.css({ "left": (dir * -1) + "%" }).animate({ "left": "0" }, 250);
                    }, 100);
                });
            });
        }
        // Image - single slide
        else {
            MediaPreviewUpdate($slide, "&nbsp");
            $("#zoom .toggle_slide").remove(); // Hide change slide buttons
        }

        // Close zoom button by X button
        $("#page_fader .close").click(function() {
            $("#zoom textarea").blur();
            $("#page_fader").fadeOut(ANIMATION_TIME, function() { $(this).remove(); });
            $("body").css({ "overflow-y": "scroll" });
            $("body").unbind("keyup");

            if(
                ($button.attr("class") != undefined && $button.attr("class").indexOf("visible") > -1) ||
                $("nav").attr("class").indexOf("mobile") > -1
            ) {
                $("#lang, #toogle_mobile_menu").fadeIn(ANIMATION_TIME);
            }
        });
        
        // Close & navigate by key
        $("body").keyup(function(e) {
            code = e.keyCode;
            if(code == 27) { // ESC
                $("#page_fader .close").click();
            }
            else if(code == 37) { // <-
                $("#zoom .image_box button.prev").click();
            }
            else if(code == 39) { // ->
                $("#zoom .image_box button.next").click();
            }
        });

        // Blur focus outline
        $(this).blur();
        return false;
    });

};

function uploadLimitsTest() {
    var num = 0;
    $("input.upload_file").each(function() {
        val = $(this).val();
        if(val) { num++ };
    })
    if(num > MAX_UPLOADS) {
        showPopup("fi-alert", LOCALIZE["upload-inputs-limit-html"], LOCALIZE["ok-label"], false);
        $("#popup_box .confirm").click(function() { hidePopup(); });
    }
};

function fixFilename(basename) {
    return basename.path("filename").makeId() + "." + basename.path("extension");
};

function uniqFilename(filename) {
    var ext = filename.path("extension");
    return filename.path("filename") + "_" + currentTime("yyyymmdd-homise") + "." + ext;
};

function initializeUpload() {
// --------------------------------
// Initialize upload button action
// --------------------------------
    initializeLinkUpdate();
    //UploadCancelFix();
    $("input.upload_file").unbind("change").on("change", function() {
        uploadLimitsTest();
        var $input = $(this);
        var $gallery = $input.closest("div.upload").parent();
        var folder = $gallery.attr("value");
        var media_type = getItemTag($gallery);
        files = $input.get(0).files;
        var filenames = [];
        for(n = 0; n < files.length; n++) {
            filenames[filenames.length] = folder + "/" + files.item(n).name;
        };
        // ====== IMAGE or FILE ======
        if(media_type == "image" || media_type == "file") {
            //currentTime("yyyymmdd-homise");
            var taken = $input.parent(".upload").find(".taken_filenames").val().split(";");
            taken = taken.concat(TAKEN_BY_UPLOAD);
            var filename = fixFilename( filenames[0] );
            if(taken.indexOf(filename) > -1) { filename = uniqFilename(filename); };
            path = folder + "/" + filename;
            filenames[0] = path;
            $input.closest("div." + media_type).attr("value", path);
            TAKEN_BY_UPLOAD[TAKEN_BY_UPLOAD.length] = filename;
        }
        // ====== GALLERY or FILES ======
        else {
            var folder = folder.split(";").shift().path("dirname");
            var taken = $input.parent(".upload").find(".taken_filenames").val().split(";");
            taken = taken.concat(TAKEN_BY_UPLOAD);
            for(n in filenames) {
                var filename = fixFilename(filenames[n]);
                if(taken.indexOf(filename) > -1) { filename = uniqFilename(filename); };
                path = folder + "/" + filename;
                filenames[n] = path;
                TAKEN_BY_UPLOAD[TAKEN_BY_UPLOAD.length] = filename;
            };
            var gallery_files = $gallery.attr("value");
            if(gallery_files.split(";").shift().path("extension") != "" && gallery_files != "") {
                $gallery.attr("value", gallery_files + ";" + filenames.join(";"));
            }
            else {
                $gallery.attr("value", filenames.join(";"));
            };
        };
        // ====== Maximum number of uploads exceed alert ======
        if(TAKEN_BY_UPLOAD.length > MAX_UPLOADS) {
            var text = LOCALIZE["max-upload-exceeded"].replace("@number", MAX_UPLOADS);
            showPopup("fi-alert", text, LOCALIZE["ok-label"], false);
            $("#popup_box .confirm").click(function() { hidePopup(); });
        }
        // ====== Upload button / thumbnails ======
        // Update button from upload to images selected
        var $upload = $input.closest("div.upload");
        var label = $upload.find("label").get(0).outerHTML;
        var $media = $upload.parent("div");
        // Remove any "fake" upload images divs
        $media.find(".fake").remove();
        // Create uploaded image icon(s)
        for(n in filenames) {
            label = label.replace(/<p>(.*?)<\/p>/, "<p>" + filenames[n].path("basename") + "</p>");
            $upload.parent("div").append("<div class='upload fake'>" + label + "</div>");
        };
        if(media_type == "file") { icon = "fi-page"; } else { icon = "fi-photo"; };
        $media.find(".fake label").removeClass("fi-upload").addClass(icon); // change icon to picture
        $media.find(".upload").css({ "background-color": "#ffffff" }); // non transparent bg color
        // ====== Add file(s) path(es) to upload list ======
        if(media_type != "gallery" && media_type != "files") { upload_filenames = "force:" + filenames.join(";"); }
        else { upload_filenames = "auto:" + filenames.join(";"); };
        //alert(upload_filenames);
        var $upload_filenames = $input.parent(".upload").find(".upload_filenames");
        
        $upload_filenames.val(upload_filenames);
        transparentBackground();
        for(n in filenames) {
            if(filenames[n].path("extension").indexOf("tif") > -1) {
                showPopup("fi-alert", LOCALIZE["tiff-alert-html"], LOCALIZE["ok-label"], false);
                $("#popup_box .confirm").click(function() { hidePopup(); });
            };
        };    

        $gallery.children(".upload").first().hide(ANIMATION_TIME); // Hide upload button
        initializeDeleteUpload($gallery);
    });
};

function initializeDeleteUpload($gallery) {
    var html = "<div class='delete_upload'><button class='help' help='" + LOCALIZE["delete-upload"] + "'><span class='fi-x'></span></button></div>";
    $gallery.append(html);
    $gallery.find(".delete_upload button").show(ANIMATION_TIME);
    
    initializeHelp();
    $gallery.find(".delete_upload button").click(function() {
        $(this).blur();
        var $gallery = $(this).closest("div.delete_upload").parent();
        var $input = $gallery.find("input.upload_file");
        var files = [];
        
        $gallery.children(".thumb").each(function() {
            files[files.length] = $(this).attr("path");
        })
        if(files.length == 0) { files[0] = $gallery.attr("value").split(";").shift().path("dirname"); };
        $gallery.attr("value", files.join(";"));

        $gallery.children(".upload").first().show(ANIMATION_TIME, function() {
            $gallery.children(".fake, .delete_upload").hide(ANIMATION_TIME, function() { $(this).remove(); });
        });

        $input.prop('disabled', false);
        $gallery.find("upload_filenames").val("");
        return false;
    })
};

function uploadHideShow() { // call in initializeDeleteMedia()
// --------------------------------
// Hide/Show upload image button
// --------------------------------
    // Images & Files
    $("div.media div.image, div.media div.file").each(function() {
        src = $(this).attr("value");
        upload = $(this).find(".upload_filenames").val();

        if(src.path("extension") != "" && upload == "") { // Image exists -> hide Upload button
            $(this).find("div.upload").hide();
        }
        else if(!$(this).children("div.fake").length) { // No image (or upload fake image) -> show Upload button
            $(this).find("div.upload").show();
        };
    });
    // Links
    $("div.media div.video .embed").each(function() {
        $iframe = $(this).find("iframe");
        $delete_button = $(this).find("button.delete");
        src = $iframe.attr("src");
        if(src == "") {
            $iframe.hide();
            $delete_button.hide();
        }
        else {
            $iframe.show();
            $delete_button.show();
        };
    });
};

// ==========================================
//                  Images
// ==========================================

// Show not_found path on hover
function showNotFoundImages() {
    $("div.not_found").each(function() {
        path = $(this).closest("div.image").attr("value");
        $(this).addClass("help").attr("help", path);
        initializeHelp();
    });
};

function addToDeleteFiles(path) {
    files = $("input#delete_files").val();
    if(files == "") { files = []; } else { files = files.split(";"); };
    files[files.length] = path;
    $("input#delete_files").val( files.join(";") );
    //alert("addToDeleteFiles: " + path);
};

function addToDeleteFolders(path) {
    files = $("input#delete_folders").val();
    if(files == "") { files = []; } else { files = files.split(";"); };
    files[files.length] = path;
    $("input#delete_folders").val( files.join(";") );
};

function initializeDeleteMedia() {
// --------------------------------
// Initialize Delete Image button actions & gallery images sorting change
// --------------------------------
    $("div.media button.move_left").unbind("click").click(function() {
        $(this).blur();
        $("#help_popup").stop();
        $thumb = $(this).parent(".thumb");
        $gallery = $thumb.parent();
        $prev = $thumb.prev();
        if($prev.length && getItemTag($prev) == "thumb") {
            $clone = $thumb.clone();
            $prev.before($clone);
            $prev.prev().hide();
            $thumb.hide(250, function() { $(this).remove(); });
            $prev.prev().show(250, function() {
                initializeDeleteMedia();
                galleryValueUpdate($gallery);
            });
        };
        initializeMediaPreview();
        return false;
    });
    $("div.media button.move_right").unbind("click").click(function() {
        $(this).blur();
        $("#help_popup").stop();
        $thumb = $(this).parent(".thumb");
        $gallery = $thumb.parent();
        $next = $thumb.next();
        if($next.length && getItemTag($next) == "thumb") {
            $clone = $thumb.clone();
            $next.after($clone);
            $next.next().hide();
            $thumb.hide(250, function() { $(this).remove(); });
            $next.next().show(250, function() {
                initializeDeleteMedia();
                galleryValueUpdate($gallery);
            });
        };
        initializeMediaPreview();
        return false;
    });

    $("div.media button.delete").unbind("click").click(function() {
        $("#help_popup").stop();
        var $thumb = $(this).closest("div.thumb");
        var $gallery = $thumb.parent("div");
        var media_type = getItemTag($gallery);
        if(media_type == "video") {
            $video = $thumb.closest("div.video");
            $video.attr("value", "");
            $video.find("iframe").fadeOut(200).attr("src", "");
            $video.find("button.delete").hide();

            if($video.find("input.video_thumb").length) {
                $thumb = $video.find("input.video_thumb");
                thumb = $thumb.val();
                addToDeleteFiles(thumb);
                $thumb.remove();
            };
        }
        else {
            if(media_type == "image" || media_type == "file") {
                path = $gallery.attr("value");
                folder = path.path("dirname");
                file = path.path("basename");
                $gallery.attr("value", folder); // Left the folder only
            }
            else if(media_type == "gallery" || media_type == "files") {
                files = $gallery.attr("value").split(";"); // all files list
                folder = files[0].path("dirname");
                path = $thumb.attr("path");
                path = decodeURI(path);
                //alert("to delete: " + path);
                files_mod = [];
                for(i in files) {
                    file = files[i];
                    if(file != path) { files_mod[files_mod.length] = file; };
                };
                if(files_mod.length > 0) {
                    $gallery.attr("value", files_mod.join(";"));
                }
                else {
                    $gallery.attr("value", folder);
                };
            };
            // ====== Add file path to Delete Files list ======
            addToDeleteFiles(path)
            // ====== Hide image & show Upload button ======
            $thumb.hide(500, function() {
                $(this).remove();
            });
            uploadHideShow();
            // End
        };
        $(this).blur();
        return false;
    });
};

function initializeSet() {
// --------------------------------
// Initialize set change trigger
// --------------------------------
    $("div.set input").unbind("change").on("change", function() {
        // Change bacground color
        $(this).closest("section").find("label").removeClass("checked");
        $(this).closest("label").addClass("checked");
        set = $(this).val();
        $(this).closest("section").find("div.media").children("div").hide(200);
        $(this).closest("section").find("div.media").children("div." + set).show(200);
    });
};

function mediaHideShow() {
// --------------------------------
// Show only current set media box
// --------------------------------
    $("div.set").each(function() {
        set = $(this).find("input:checked").val();
        $(this).find("label").removeClass("checked");
        $(this).find("input:checked").parent("label").addClass("checked");
        $(this).closest("section").find("div.media").children("div").hide();
        $(this).closest("section").find("div.media").children("div." + set).show();
    });
};

function singleSetHide() {
// --------------------------------
// Hide single media type set labels
// --------------------------------
    $("section div.set").each(function() {
        $section = $(this).closest("section");
        if( $section.find("input.type").val() == "media") {
            if($section.find("div.media").children("div").length == 1) {
               $(this).hide();
            };
        };
    });
};

/*
function updateMediaValue() {
    $("section > div.media").each(function() {
        $(this).children(".gallery, .files").each(function() {
            pathes = [];
            $(this).children(".thumb").each(function() {
                if(path = $(this).attr("path") && jQuery.type(path) == "string" && path != "") {
                    pathes[pathes.length] = path;
                };
            });
            $(this).attr("value", pathes.join(";"));
        });
    });
};
*/

// ==========================================
//          Template @path update
// ==========================================

function updateTemplatePathes() {
    if(EDIT_PATH.path("extension") == "template" && EDIT_PATH != SAVE_PATH) {
        patterns = [];
        saveas = SAVE_PATH.split("/");
        patterns['basename'] = saveas.pop();
        patterns['filename'] = patterns['basename'].path("filename");
        patterns['folder'] = saveas.pop();

        $("form .media").children("div").each(function() {
            val = $(this).attr("value");
            if(jQuery.type(val) == "string" && val != "") {
                for(pattern in patterns) {
                    repl = patterns[pattern];
                    find = new RegExp("@" + pattern, "g");
                    val = val.replace(find, patterns[pattern]);
                };
                $(this).attr("value", val);
            };
        });
    }
};